//: C05:MemberClass.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Členská šablona třídy.
#include <iostream>
#include <typeinfo>
using namespace std;

template<class T> class Vnejsi {
public:
  template<class R> class Vnitrni {
  public:
    void f();
  };
};

template<class T> template<class R>
void Vnejsi<T>::Vnitrni<R>::f() {
  cout << "Vnejsi == " << typeid(T).name() << endl;
  cout << "Vnitrni == " << typeid(R).name() << endl;
  cout << "Celá Vnitrni == " << typeid(*this).name() << endl;
}

int main() {
  Vnejsi<int>::Vnitrni<bool> vnitrni;
  vnitrni.f();
} ///:~
